var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    showAppTitle();
    
    imgLogo=document.getElementById("Logo");
    img=document.getElementById("03");
    
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
    
function initialiseEvents(){
    $("#visualisation").contextmenu(function(evt){
        evt.preventDefault();
        evt.stopPropagation();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove(evt);
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp(evt);
    });
    
    $("#visualisation").on("mouseout",function(evt){
        imgLogo=document.getElementById("Logo");
        drawBasicScreen();
    });
}

function initialValues(){
    width=canvas.width;
    height=canvas.height;
    iw=img.width;
    ih=img.height;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgMainLeft=(width-2*iw-ImageBorder)/2;
    imgMainTop=TopPanelHeight+60;
    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
}

function initialiseGUI(){
    zoomFactor=document.getElementById("scrZoomFactor");
    document.getElementById("matrixSwitch").checked=false;

    InitialiseGUI_values();
}

function InitialiseGUI_values(){
    zoomFactor.value=1;
    performZoom();
}

function drawBasicScreen(){
    //Φόντα οθόνης
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    cntx.fillStyle=MainAreaColor;
    cntx.fillRect(0,0,width,height);

    cntx.fillStyle=PanelColor;
    cntx.fillRect(0,0,width,TopPanelHeight);
    cntx.fillRect(0,BottomPanelTop,width,BottomPanelHeight);
    //Τίτλος εφαρμογής
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    //Εικόνες
    cntx.imageSmoothingEnabled=true;
    cntx.drawImage(img,imgMainLeft,imgMainTop);
    cntx.imageSmoothingEnabled=false;
    
    cntx.drawImage(img,0,0,iw/zoomFactor.value,ih/zoomFactor.value,imgMainLeft+iw+ImageBorder,imgMainTop,iw,ih);
    //cntx.drawImage(img,(1-1/zoomFactor.value)*iw/2,(1-1/zoomFactor.value)*ih/2,iw/zoomFactor.value,ih/zoomFactor.value,imgMainLeft+iw+ImageBorder,imgMainTop,iw,ih);
    if(matrixOn)showMatrix();
    var noOfColors=countDistinctColors();
    var colorInfo="";
    
    if(zoomFactor.value>20){
        colorInfo="Η εικόνα αποτελείται από "+noOfColors+" αποχρώσεις και δεν είναι σαφής πλέον.";
    }
    else if(zoomFactor.value>10){
        colorInfo="Η εικόνα αποτελείται από "+noOfColors+" αποχρώσεις και είναι πολύ θολή.";
    }
    else{
        colorInfo="Η εικόνα περιέχει περισσότερες από "+noOfColors+" αποχρώσεις.";
    }
    

    cnvsWrite(LetterColor,15,"Arial",imgMainLeft,imgMainTop+CaptionBorder+ih,"Αρχική εικόνα");
    cnvsWrite(LetterColor,15,"Arial",imgMainLeft+iw+ImageBorder,imgMainTop+CaptionBorder+ih,"Ψηφιδωτό");

    var InfoLeft=120;
    cnvsWrite(LetterColor,fontSize-8,"Arial",InfoLeft,BottomPanelTop+25,"Χρησιμοποίησε τη μπάρα κύλισης για να αλλάξεις το μέγεθος των ψηφίδων.");
    //if(zoomFactor.value>6){
        cnvsWrite(LetterColor,fontSize-8,"Arial",InfoLeft,BottomPanelTop+55,colorInfo);
    //}
    
    //Πλαίσια μαύρου χρώματος
    cntx.strokeStyle="rgb(0,0,0)";
    cntx.beginPath();
    cntx.rect(0,0,width-1,TopPanelHeight);
    cntx.rect(0,TopPanelHeight,width-1,height-TopPanelHeight-BottomPanelHeight);
    cntx.rect(0,BottomPanelTop,width-1,BottomPanelHeight-1);
    cntx.rect(imgMainLeft,imgMainTop,iw,ih);
    cntx.rect(imgMainLeft+iw+ImageBorder,imgMainTop,iw,ih);
    cntx.stroke();
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseMove(evt){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
        drawBasicScreen();
    }
    else {
        imgLogo=document.getElementById("Logo");
        drawBasicScreen();
        ShowProgramID=false;
    }
    //console.log("mx="+mx+" , my="+my+" , introStep="+introStep);
}

function handleMouseUp(evt){
    evt.preventDefault();
    isButtonPressed=false;
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        if(MyInfo){
            ShowProgramID=!ShowProgramID;
        }
        else {
            showHTML();
        }
    }
    drawBasicScreen();
}

function performZoom(){
    $("#zoomFactorValue").html(zoomFactor.value);
    drawBasicScreen();
    
}

function countDistinctColors(){
    var distinctColors=[];
    var pixels=cntx.getImageData(imgMainLeft+iw+ImageBorder,imgMainTop,iw,ih).data;
    for(var i=0;i<ih;i+=parseInt(zoomFactor.value)){
        for(var j=0;j<iw;j+=parseInt(zoomFactor.value)){
            var dataIndex=i*iw+j;
            var pxlColor=((pixels[dataIndex] << 16) | (pixels[dataIndex+1] << 8) | pixels[dataIndex+2]).toString(16);
            var found=false;
            var k=0;
            if(distinctColors.length<500){
                while(k<distinctColors.length && !found){
                    if(distinctColors[k]==pxlColor){
                        found=true;
                    }
                    k++;
                }
                if(!found){
                    distinctColors.push(pxlColor);
                }
            }
        }
        
    }
    /*for(var i=0;i<pixels.length;i+=4){
        var pxlColor=((pixels[i] << 16) | (pixels[i+1] << 8) | pixels[i+2]).toString(16);
        var found=false;
        var j=0;
        if(distinctColors.length<500){
            while(j<distinctColors.length && !found){
                if(distinctColors[j]==pxlColor){
                    found=true;
                }
                j++;
            }
            if(!found){
                distinctColors.push(pxlColor);
            }
        }
    }*/
    //noOfDistinctColors=distinctColors.length;
    return distinctColors.length;
}

function showMatrix(){
    cntx.strokeStyle="rgb(120,120,120)";
    cntx.beginPath();
    var xOffset=imgMainLeft+iw+ImageBorder;
    for(var i=0;i<ih/zoomFactor.value;i++){
        cntx.moveTo(xOffset,imgMainTop+i*zoomFactor.value);
        cntx.lineTo(xOffset+iw,imgMainTop+i*zoomFactor.value);
    }
    for(var j=0;j<iw/zoomFactor.value;j++){
        cntx.moveTo(xOffset+j*zoomFactor.value,imgMainTop);
        cntx.lineTo(xOffset+j*zoomFactor.value,imgMainTop+ih);
    }
    cntx.stroke();
}

function toggleMatrixSwitch(){
    matrixOn=!matrixOn;
    drawBasicScreen();
}